<template>
<div class="ModalContact">

    <div class="ModalContact__thank" v-if='success'>
        <div>
            <h2>Thank you</h2>
            <p>We will soon be in touch</p>
        </div>
    </div>
    <div v-else class="ModalContact__form">
        <h2>Get in Touch<br/>with Us</h2>
        <form name="contact-us" @submit.prevent='onSubmit'>
            <input type="email"
                autocomplete="email"
                name="email"
                placeholder="Email"
                v-model='valueEmail'/>
            <input type="text" name="subj" placeholder="Subject" v-model='valueSubj'/>
            <textarea name="text" placeholder="Tell us" v-model='valueText'/>
            <button type="submit" class="button2"
                :disabled='(disabled || pending) ? "" : null'>Submit</button>
        </form>
    </div>

    <button class="ModalContact__close"
        area-label="Close"
        @click="close"/>
</div>
</template>

<style lang="less">
@import '@/assets/css/vars.less';
.ModalContact {
    @keyframes appear {from {opacity: 0}}

    position: relative;
    box-sizing: border-box;
    max-width: 1920px;
    padding: 0 7.3%;
    width: 1200px;
    width: 100%;
    height: 100%;
    display: flex;
    flex-flow: column nowrap;
    align-items: stretch;
    justify-content: center;

    &__close {
        position: absolute;
        right: 0; top: 0;
        height: 60px;
        width: 60px;
        border: 0;
        color: @color-darkblue;
        background: transparent;
        &::before {
            font: 48px/30px Verdana;
            display: inline-block;
            content: '\00D7';
            padding: 0 0 7px 2px;
        }
        &:hover {
            color: white;
            background: @color-darkblue;
        }
    }

    &__thank {
        animation: .5s linear 0s 1 appear;
        background: transparent url(./image1.svg) no-repeat 100% 0;
        box-sizing: border-box;
        height: 740px;
        padding: 0 658px 0 0;
        display: flex;
        flex-flow: column nowrap;
        align-items: flex-end;
        justify-content: center;
        & > div {
            margin: 50px 0 0;
            h2 {margin: 0}
            p {
                margin: 90px 0 0;
                text-align: center;
            }
        }
    }

    &__form {
        animation: .5s linear 0s 1 appear;
        background: transparent url(./image.svg) no-repeat 88% 175px;
        padding: 0px 0 0px;
        form {
            max-width: 583px;
            input, textarea {
                width: 100%;
                display: block;
                margin: 0 0 1em;
                background-color: rgba(255, 255, 255, .975);
            }

            input[name="email"] {
                max-width: 424px;
            }

            input[name="subj"] {
                max-width: 330px;
            }

            textarea {
                resize: none;
                width: 100%;
            }

            button {
                display: block;
                margin: 0 0 0 auto;
            }

        }
    }
}
</style>

<script lang="ts">
import {Vue, Options} from '@/vue';
@Options<ModalContact>({}) export default class ModalContact extends Vue {
    valueEmail:string = '';
    valueText:string = '';
    valueSubj:string = '';
    pending:boolean = false;
    success:boolean = false;

    get disabled():boolean {
        return !this.valueEmail;
    }

    onSubmit() {
        this.pending = true;
        setTimeout(() => this.onSuccess(), 500);
    }

    timeout:number = 0;
    onSuccess() {
        console.log('SUCCESS');
        this.pending = false;
        this.success = true;
        this.timeout = window.setTimeout(() => this.close(), 2000);
    }

    close() {
        if (this.timeout) clearTimeout(this.timeout);
        this.pending = false;
        this.success = false;
        this.$emit('close');
    }
}
</script>
